var total_assignments = 0; //total number of class assignments
var total_students = 0; //total number of students in class

var json = ({
        document_title : "Untitled",
        teacher_name : "Teacher Name",
        file_path : "new",
        
        assignments : new Array(),
        students : new Array()
  });
//json.assignments[0] = ({ date:"1/1/08", abbr:"T1", title:"Test 1", type:"T" });
var backup = "";


function fileFormatConverter(info,data)
{
  //File summary
  json = ({
        document_title : info[0][0],
        teacher_name : info[0][1],
        file_path : info[0][2],
        
        assignments : new Array(),
        students : new Array()
  });

  //Assignment info
  for (i=1; i<info.length; i++)
    json.assignments[i-1] = { 
        date : info[i][0],
        abbr : info[i][1],
        title : info[i][2], 
        type : info[i][3],
        max : data[0][i]
    };
  data.shift();
  
  //Student names and points
  for (i=0; i<data.length; i++)
    json.students[i] = { 
        name : data[i].shift(),
        points : data[i]
    }
  
}

window.onload = function()
{
  notify(); //clear notice about javascript required

  /*globalStorage['localhost'].lastsaved = "testing"*/
  
  if (document.cookie) {
    importData(readCookie("Grade_Book"));
  }//notify(JSON.stringify(json.assignments))
  
  if ((output = xpcomFileRead(json.file_path))) {
	  importData(output);
  }
  
  if (total_students < 1) notify("Try adding new students first");
  /*
  if(globalStorage.gradebook) {
    alert(globalStorage.gradebook);
  }
  */
  
  // onclick events for buttons above table
  el("gradebook").onsubmit = submitForm;
  el("save_as_button").onclick = saveAs; //fileSummaryDialog;
  el("open_button").onclick = openFile;
  el("undo_button").onclick = undo;
  el("redo_button").onclick = redo;
  
  // onclick events for assignment headings
  for (var i=0; i < total_assignments; i++)
    el(i).onclick = editAssignmentDialog;
  
  // onchange events for input boxes within table
  var table_inputs = el("gradebook").getElementsByTagName("input");
  for (var i=0; i < table_inputs.length; i++) {
    if (table_inputs[i].type == "text") table_inputs[i].onchange = submitForm;
    if (table_inputs[i].size == 3) table_inputs[i].onfocus = assignmentDetails;
  }
  
  // onclick events for buttons below table
  el("new_assignment_button").onclick = newAssignmentDialog;
  el("new_student_button").onclick = addStudent;
  el("delete_students_button").onclick = deleteStudents;
  
  //keyboard shortcuts
  if (window.event)
    document.onkeydown = keyBindings; //Able to capture ctrl key on IE
  else 
    document.onkeypress = keyBindings;

    //set form elements
	el("sourcecode").value = packageArrays();
  //el("sourcecode").value = json.toSource();
  
  el("undo_button").disabled = true;
  
}



function keyBindings(e)
{
  // Get key
  var keynum;
 
  if (window.event) {// IE
    keynum = event.charCode ? event.charCode : event.keyCode;
    e = window.event;
  } else if (e.which) {// Netscape/Firefox/Opera
    keynum = e.which;
  }
  

  var keychar = String.fromCharCode(keynum).toUpperCase();//keypress captures lowercase, keydown uppercase regardless
  //notify(keynum+" "+keychar+" "+e.ctrlKey);
  
  // Key bindings
  if (e.ctrlKey && !e.shiftKey)
  switch (keychar) {
  case "F" :
    notify("f");
    break;
  case "S" :
    submitForm();
    notify("File saved");
    return false;
    break;
  case "O" :
    openFile();notify("open");
    return false;
    break;
  }
}

//adds onchange events for all input boxes within main table
//temp solution until onchange added individually to each new element on addStudent or addAssignment
function updateOnChangeEvents() {
  var table_inputs = el("gradebook").getElementsByTagName("input");
  for (var i=0; i < table_inputs.length; i++) {
    if (table_inputs[i].type == "text") table_inputs[i].onchange = submitForm;
    if (table_inputs[i].size == 3) table_inputs[i].onfocus = assignmentDetails;
  }
}

function assignmentDetails()
{
  var i = this.id.match(/[0-9]+/)[0];
  notify(json.assignments[i].title + ", " + json.assignments[i].type + " (" + json.assignments[i].date + ")")
}

function el(id) 
{ 
 if (document.getElementById) { 
   return document.getElementById(id); 
 } else if (window[id]) { 
   return window[id]; }
 return null;
}

//displays messages to user (such as error messages)
function notify(message,permanent)
{
  if (message) {
    el("notice").style.visibility = "visible";
    el("notice").innerHTML = message;
    //if (!permanent) setTimeout("el('notice').style.visibility = 'hidden';",9000);
  } else {
    el("notice").style.visibility = "hidden";
  }
}

function submitForm()
{ 
  updateArrays();
  updatePercentages();
  
  return false; //prevents HTML from reloading
}

//Calculates percentages for each student and updates display
function updatePercentages()
{
  for (j = 0; j < total_students; j++) {
    var points = 0; //stores running point total for student grade
    var points_Max = 0; //store running point total for student max grade
    
    for (i = 0; i < total_assignments; i++) {
      if (el(i+"_"+j).value != "EXC") {
        points += (el(i+"_"+j).value == "") ? 0 : eval(el(i+"_"+j).value);
        points_Max += eval(el(i+"_Max").value);
        
        //Mark scores above max or empty scores in student points
        if (eval(json.students[j].points[i]) > eval(json.assignments[i].max)) { 
          el(i+"_"+j).className = "extra_credit";
          notify('Star (<img src="./images/star.png" alt="Extra Credit" />) indicates a score higher than max');
        } else if (json.students[j].points[i] == "") {
          el(i+"_"+j).className = "error"; 
          notify('Red mark (<img src="./images/error.png" alt="Error" />) indicates a blank score');
        } else {
          el(i+"_"+j).className = "";
        }
        
        
        // Display errors in assignment max points (no score entered)
        if (json.assignments[i].max == "") el(i+"_Max").className = "error";
        else el(i+"_Max").className = "";
      }
    }
    
    var percent = (points_Max == 0) ? 100 : points / points_Max * 100;
    el("Percent_"+j).innerHTML = Math.round(percent*100)/100 + "%"; //parseInt(percent);
    
  }
}

function packageArrays()
{/*
  var save1 = new Array();
  var save2 = new Array();
  for (i=0; i < data.length; i++) {
    save1[i] = data[i].join("|");
  }
  for (i=0; i < info.length; i++) {
    save2[i] = info[i].join("|");
  }
  return save1.join("\n")+"\n***"+save2.join("\n");*/
  return JSON.stringify(json);
}

function processFile(file)
{
  backupSave(); //Make backup copy in case undo is needed
  
  if (file.indexOf("\n***")!=-1) {
    var info = [0] //initialize
    var data = [0] //initialize
    file += "";
    var split0 = file.split("\n***");
    var split1 = split0[0].split("\n");
    var split2 = split0[1].split("\n");
    for (i=0; i < split1.length; i++) {
      data[i] = split1[i].split("|");
    }
    for (i=0; i < split2.length; i++) {
      info[i] = split2[i].split("|");
    }
    
    fileFormatConverter(info,data);
  } else {
    json = JSON.parse(file);
  }
}

function updateArrays()
{
  //Make backup copy of data and info arrays (in case undo is needed)
  backupSave();
  
  while (json.assignments.length < total_assignments) 
    json.assignements.push({});
  while (json.students.length < total_students)
    json.students.push({ name:"", points:[] });
  
  // Max points for each assignment
  for (i = 0; i < total_assignments; i++) {
    json.assignments[i].max = el(i+"_Max").value;
  }
  
  // Student points for each assignment
  for (j = 0; j < total_students; j++) {
    json.students[j].name = el("Student_"+j).value;
    
    for (i = 0; i < total_assignments; i++) {
      json.students[j].points[i] = el(i+"_"+j).value;
    }
  }

  // Assignment titles
  for (i = 0; i < total_assignments; i++) {
    json.assignments[i].abbr = el(i).innerHTML;
  }
  
  //Delete any leftovers
  if (json.assignments.length > total_assignments)
    json.assignments.splice(total_assignments,total_assignments-json.assignments.length);
  if (json.students.length > total_students)
    json.students.splice(total_students,total_students-json.students.length);
  
  // Save changes
  save()
}

function save()
{
  notify() //clear notifications;
  
  el("sourcecode").value = packageArrays();
  updateCookie(packageArrays());
  
  // Local file save
  xpcomFileWrite(json.file_path, packageArrays());

  //globalStorage.gradebook = save.join("\n");
}

// Make backup copy in case undo is needed
function backupSave()
{
  backup = packageArrays();
  el("undo_button").disabled = false;
  el("redo_button").disabled = true;
}

function undo()
{
  importData(backup);
  save();
  el("undo_button").disabled = true;
  el("redo_button").disabled = false;
}

function redo()
{
  importData(backup);
  save();
  el("redo_button").disabled = true;
  el("undo_button").disabled = false;
}

function importData(file)
{
  if (file=="") { file = "Max|100\nJoe|92\n***Untitled|Teacher Name|C:\\Grade Book\\Untitled.txt\n1/1/08|T1|Test 1|T"; }
  if (file) {
    // Process file
    processFile(file);
  }

  // Add new rows to table if needed
  while (total_students < json.students.length) {
    total_students += 1;
    addRow();
  }
  //Subtract extra rows if needed
  while (total_students > json.students.length) {
    total_students += -1;
    deleteRow();
  }
  
  // Add new columns to table if needed
  while (total_assignments < json.assignments.length) {
    total_assignments += 1;
    addCol();
  }
  while (total_assignments > json.assignments.length) {
    total_assignments += -1
    deleteCol();
  }
  

  // Update max points display
  for (i = 0; i < total_assignments; i++) {
    el(i+"_Max").value = json.assignments[i].max;
  }
  
  // Update student names and student points for each assignment
  for (j = 0; j < total_students; j++) {
    el("Student_"+j).value = json.students[j].name; //stores the sudents name
    for (i = 0; i < total_assignments; i++) {
      el(i+"_"+j).value = json.students[j].points[i]
    }
  }
  
  //Update titles for each assignment
  for (i = 0; i < total_assignments; i++) {
    el(i).innerHTML = json.assignments[i].abbr;//notify(json.assignments[i].abbr)
    el(i).title = json.assignments[i].title;
  }
  
  //Caluculations percent for each student and update display
  updatePercentages();
  
  //Update table events
  updateOnChangeEvents();
  
  //Update page title
  document.title = json.document_title + " - Grade Book";
}
    
function addStudent()
{ 
  total_students += 1;
  addRow();
  updateArrays();
  save();
  updatePercentages();
  updateOnChangeEvents();
  el("Student_"+(total_students-1)).focus();
  el("Student_"+(total_students-1)).select();
}

function addRow()
{  
  //create new row at end of table
  var new_row = el("gradebooktable").insertRow(-1);
  
  //create student name cell
  var header_cell = document.createElement('th');
  new_row.appendChild(header_cell);
  header_cell.innerHTML = '<input type="checkbox" id="Select_' + (total_students-1)
          + '" /><input type="text" value="New Student" id="Student_' + (total_students-1) + '" size="15" tabindex="20" />\n';
  
  //create percent cell
  var new_cell = new_row.insertCell(1);
  new_cell.className = "noedit";
  new_cell.innerHTML = '<span id="Percent_' + (total_students-1) + '">%</span>\n';
  
  //create remaining data cells
  for (i = 0; i < total_assignments; i++) {
    var new_cell = new_row.insertCell(i+2);
    new_cell.innerHTML = '<input type="text" value="" id="' + i + "_" + (total_students-1) + '" size="3" tabindex="'
           + 10*(i+4) + '" />\n';
  }
}

function deleteStudents()
{
  backupSave();

  var none_checked = true; //flag
  
  for(i = total_students-1; i >= 0; i--) {
    if (el("Select_"+i).checked) {
      el("Select_"+i).checked = false;
      total_students -= 1;
      json.students.splice(i,1);
      deleteRow();
      none_checked = false;
    }
  }
  
  if (none_checked) {
    notify("No students marked for deletion.\n\nUse checkboxes next to student name to mark for deletion.");
  } else {
    save();
    importData();
  }
}

function deleteRow()
{
  el("gradebooktable").deleteRow(-1);
}

function editAssignmentDialog()
{
  var i = this.id;
  el("assignment").getElementsByTagName("h2")[0].innerHTML = 'Edit Assignment '+i;
  //el("assignment_buttons").innerHTML = '<input type="submit" class="default" value="Apply" tabindex="1" /><input type="button" value="Delete assignment" tabindex="1" onclick="deleteAssignment('+i+');el(\'assignment\').style.display = \'none\';" /><input type="button" value="Cancel" tabindex="1" onclick="el(\'assignment\').style.display = \'none\'; el(\'new_assignment_button\').disabled = false;" />';
  el("add_assignment_buttons").style.display = "none";
  el("edit_assignment_buttons").style.display = "block";
  
  el("date").value = json.assignments[i].date;
  el("abbr_title").value = json.assignments[i].abbr;
  el("full_title").value = json.assignments[i].title;
  el("type").value = json.assignments[i].type;
  
  el("assignment").style.display = "block";
  el("assignment").onsubmit = editAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function editAssignment()
{
  backupSave();
  
  var heading = el("assignment").getElementsByTagName("h2")[0].innerHTML
  var i = heading.substring(heading.length-1,heading.length);
  json.assignments[i] = {
        date : el("date").value,
        abbr : el("abbr_title").value,
        title : el("full_title").value,
        type : el("type").value,
        max : json.assignments[i].max
  };
  save();
  importData();

  el("assignment").style.display = "none"; 
  el("assignment").getElementsByTagName("h2")[0].innerHTML = 'New Assignment';
  el("edit_assignment_buttons").style.display = "none";
  el("add_assignment_buttons").style.display = "block";
  
  return false; //stops HTML from reloading
}

function newAssignmentDialog()
{
  var date = new Date();
  var year = date.getYear()+"";
  el("date").value = (date.getMonth()+1) + "/" + date.getDate() + "/" + year.substring(year.length-2,year.length);
  
  el("new_assignment_button").disabled = true;
  el("assignment").style.display = "block";
  el("assignment").onsubmit = addAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function addAssignment()
{
  total_assignments += 1;
  
  backupSave();
  json.assignments[total_assignments-1] = {
        date : el("date").value,
        abbr : el("abbr_title").value,
        title : el("full_title").value,
        type : el("type").value,
        max : ""
  };
  for (i = 0; i < total_students; i++) {
    json.students[i].points.push("");
  }
  save();

  addCol()
  importData();
  updateOnChangeEvents();
  
  el("new_assignment_button").disabled = false;
  el("assignment").style.display = "none"; 
  el(total_assignments-1+"_Max").focus();
  el(total_assignments-1+"_Max").select();
  
  return false; //prevents entire page from reloading
}

function addCol()
{
  //create assignment title cell
  var header_cell = document.createElement('th');
  el("gradebooktable").rows[0].appendChild(header_cell);
  header_cell.innerHTML = '<span title="' 
          + json.assignments[total_assignments-1].title + '" id="' + (total_assignments-1)
          + '" tabindex="' + 10*(total_assignments+3) + '">'
          + json.assignments[total_assignments-1].abbr +'</span>\n';
  
  //create max points cell
  var new_cell = el("gradebooktable").rows[1].insertCell(total_assignments+1);
  new_cell.innerHTML = '<input type="text" value="100" id="' + (total_assignments-1) 
          + '_Max" size="3" tabindex="' + 10*(total_assignments+3) + '" />\n';
  
  //create data cells for each student
  for (i = 0; i < total_students; i++) {
    var new_cell = el("gradebooktable").rows[i+2].insertCell(total_assignments+1);
    new_cell.innerHTML = '<input type="text" value="" id="' + (total_assignments-1) + "_" + i
          +'" size="3" tabindex="' + 10*(total_assignments+3) + '" />\n';;
  }
}

function deleteAssignment(i)
{
  backupSave();
  
  total_assignments -= 1;
  json.assignments.splice(i,1);
  for (var j=0; j<total_students; j++)
    json.students[j].points.splice(i,1);
  deleteCol();
  
  save();
  importData();
}

function deleteCol()
{
  //delete last cell from each row
  for (i = 0; i <= total_students+1; i++) {
    el("gradebooktable").rows[i].deleteCell(-1);
  }
}

function fullIndividualReports()
{
  var newHTML  = '<?xml version="1.0" encoding="UTF-8"?>\n'
          + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\n'
          + '   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n'
          + '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >\n'
          + '<head><title>' + json.teacher_name + ': ' + json.document_title + '</title>' // Teacher and class name
          + '<style type="text/css">td {padding-right:4em} th {text-align:left}</style></head>\n'
          + '<body onload="window.print()">\n';
  
  for (j = 0; j < total_students; j++) {
  
    // Add student name, and table headings
    newHTML  += "\n<h1>" + json.students[j].name + "</h1>\n" // Student name
          + '<table><tr><th>Title</th><th>Type</th><th>Date</th><th>Grade</th></tr>\n';
    
    // Add student data for every assignment 
    for (i = 0; i < total_assignments; i++) {
      newHTML += "<tr>\n<td>" + json.assignments[i].title //full title of assignment
          + "</td><td>" + json.assignments[i].type //type
          + "</td><td>" + json.assignments[i].date //date
          + "</td><td>" + json.students[j].points[i] //grade
          + " / " + json.assignments[i].max + "</td></tr>\n"; //max points
    }
    
    // Calculate letter grade
    var percent = el("Percent_"+j).innerHTML;
    percent = percent.substring(0,percent.length-1);
    var letter = getLetterGrade(percent);
    
    // Add overall grade
    newHTML += '</table>\n\n'
          + '<p style="page-break-after:always"><strong>Overall Grade: ' + percent + '% ' + letter + '</strong></p>\n\n';
  }
  newHTML += "</body>\n</html>";
  
  document.writeln(newHTML);
  document.close();
}

function getLetterGrade(percent)
{
  var grade; 
  
  if (percent >= 95) grade = "A"
  else if (percent >= 90) grade = "A-"
  else if (percent >= 87) grade = "B+"
  else if (percent >= 83) grade = "B"
  else if (percent >= 80) grade = "B-"
  else if (percent >= 77) grade = "C+"
  else if (percent >= 73) grade = "C"
  else if (percent >= 70) grade = "C-"
  else if (percent >= 67) grade = "D+"
  else if (percent >= 63) grade = "D"
  else if (percent >= 60) grade = "D-"
  else grade = "F";
  
  return grade;
}

function fileSummaryDialog()
{
  backupSave(); //make backup of data and info arrays in case of undo
  
  el("class_title").value = json.document_title;
  el("teacher").value = json.teacher_name;
  el("file_save_location").value = json.file_path;
  el("save_as_button").disabled = true;
  el("file_summary").style.display = "block";
  el("file_summary").onsubmit = saveFileSummary;
  el("class_title").focus();
  el("class_title").select();
}
function saveFileSummary()
{
  json.document_title = el('class_title').value;
  json.teacher_name = el('teacher').value;
  json.file_path = el('file_save_location').value;
  save();
  el("save_as_button").disabled = false;
  el("file_summary").style.display = "none";
    
  return false; //prevents entire page from reloading
}

function showSource()
{
  el("sourcecode_form").style.display = "block";
  el("show_source").innerHTML = "Hide source code";
  el("show_source").href = "javascript:hideSource();";
}
function hideSource()
{
  el("sourcecode_form").style.display = "none";
  el("show_source").innerHTML = "Show source code";
  el("show_source").href = "javascript:showSource();";
}